#import <Foundation/Foundation.h>

#define LIBFPTR_SETTING_LIBRARY_PATH @"LibraryPath"
#define LIBFPTR_SETTING_MODEL @"Model"
#define LIBFPTR_SETTING_PORT @"Port"
#define LIBFPTR_SETTING_BAUDRATE @"BaudRate"
#define LIBFPTR_SETTING_BITS @"Bits"
#define LIBFPTR_SETTING_PARITY @"Parity"
#define LIBFPTR_SETTING_STOPBITS @"StopBits"
#define LIBFPTR_SETTING_IPADDRESS @"IPAddress"
#define LIBFPTR_SETTING_IPPORT @"IPPort"
#define LIBFPTR_SETTING_MACADDRESS @"MACAddress"
#define LIBFPTR_SETTING_COM_FILE @"ComFile"
#define LIBFPTR_SETTING_USB_DEVICE_PATH @"UsbDevicePath"
#define LIBFPTR_SETTING_BT_AUTOENABLE @"AutoEnableBluetooth"
#define LIBFPTR_SETTING_BT_AUTODISABLE @"AutoDisableBluetooth"
#define LIBFPTR_SETTING_ACCESS_PASSWORD @"AccessPassword"
#define LIBFPTR_SETTING_USER_PASSWORD @"UserPassword"
#define LIBFPTR_SETTING_OFD_CHANNEL @"OfdChannel"
#define LIBFPTR_SETTING_EXISTED_COM_FILES @"ExistedComFiles"
#define LIBFPTR_SETTING_SCRIPTS_PATH @"ScriptsPath"
#define LIBFPTR_SETTING_DOCUMENTS_JOURNAL_PATH @"DocumentsJournalPath"
#define LIBFPTR_SETTING_USE_DOCUMENTS_JOURNAL @"UseDocumentsJournal"
#define LIBFPTR_SETTING_AUTO_RECONNECT @"AutoReconnect"
#define LIBFPTR_SETTING_INVERT_CASH_DRAWER_STATUS @"InvertCashDrawerStatus"
#define LIBFPTR_MODEL_UNKNOWN 0
#define LIBFPTR_MODEL_ATOL_25F 57
#define LIBFPTR_MODEL_ATOL_30F 61
#define LIBFPTR_MODEL_ATOL_55F 62
#define LIBFPTR_MODEL_ATOL_22F 63
#define LIBFPTR_MODEL_ATOL_52F 64
#define LIBFPTR_MODEL_ATOL_11F 67
#define LIBFPTR_MODEL_ATOL_77F 69
#define LIBFPTR_MODEL_ATOL_90F 72
#define LIBFPTR_MODEL_ATOL_60F 75
#define LIBFPTR_MODEL_ATOL_42FS 77
#define LIBFPTR_MODEL_ATOL_15F 78
#define LIBFPTR_MODEL_ATOL_50F 80
#define LIBFPTR_MODEL_ATOL_20F 81
#define LIBFPTR_MODEL_ATOL_91F 82
#define LIBFPTR_MODEL_ATOL_92F 84
#define LIBFPTR_MODEL_ATOL_SIGMA_10 86
#define LIBFPTR_MODEL_ATOL_27F 87
#define LIBFPTR_MODEL_ATOL_SIGMA_7F 90
#define LIBFPTR_MODEL_ATOL_SIGMA_8F 91
#define LIBFPTR_MODEL_ATOL_1F 93
#define LIBFPTR_MODEL_KAZNACHEY_FA 76
#define LIBFPTR_MODEL_ATOL_AUTO 500
#define LIBFPTR_PORT_BR_1200 1200
#define LIBFPTR_PORT_BR_2400 2400
#define LIBFPTR_PORT_BR_4800 4800
#define LIBFPTR_PORT_BR_9600 9600
#define LIBFPTR_PORT_BR_19200 19200
#define LIBFPTR_PORT_BR_38400 38400
#define LIBFPTR_PORT_BR_57600 57600
#define LIBFPTR_PORT_BR_115200 115200
#define LIBFPTR_PORT_BR_230400 230400
#define LIBFPTR_PORT_BR_460800 460800
#define LIBFPTR_PORT_BR_921600 921600
#define LIBFPTR_FNS_INITIAL 0
#define LIBFPTR_FNS_CONFIGURED 1
#define LIBFPTR_FNS_FISCAL_MODE 3
#define LIBFPTR_FNS_POSTFISCAL_MODE 7
#define LIBFPTR_FNS_ACCESS_ARCHIVE 15
#define LIBFPTR_RT_CLOSED 0
#define LIBFPTR_RT_SELL 1
#define LIBFPTR_RT_SELL_RETURN 2
#define LIBFPTR_RT_SELL_CORRECTION 7
#define LIBFPTR_RT_SELL_RETURN_CORRECTION 8
#define LIBFPTR_RT_BUY 4
#define LIBFPTR_RT_BUY_RETURN 5
#define LIBFPTR_RT_BUY_CORRECTION 9
#define LIBFPTR_RT_BUY_RETURN_CORRECTION 10
#define LIBFPTR_FFD_UNKNOWN 0
#define LIBFPTR_FFD_1_0 100
#define LIBFPTR_FFD_1_0_5 105
#define LIBFPTR_FFD_1_1 110
#define LIBFPTR_TT_DEFAULT 0
#define LIBFPTR_TT_OSN 1
#define LIBFPTR_TT_USN_INCOME 2
#define LIBFPTR_TT_USN_INCOME_OUTCOME 4
#define LIBFPTR_TT_ENVD 8
#define LIBFPTR_TT_ESN 16
#define LIBFPTR_TT_PATENT 32
#define LIBFPTR_AT_NONE 0
#define LIBFPTR_AT_BANK_PAYING_AGENT 1
#define LIBFPTR_AT_BANK_PAYING_SUBAGENT 2
#define LIBFPTR_AT_PAYING_AGENT 4
#define LIBFPTR_AT_PAYING_SUBAGENT 8
#define LIBFPTR_AT_ATTORNEY 16
#define LIBFPTR_AT_COMMISSION_AGENT 32
#define LIBFPTR_AT_ANOTHER 64
#define LIBFPTR_FN_DOC_REGISTRATION 1
#define LIBFPTR_FN_DOC_OPEN_SHIFT 2
#define LIBFPTR_FN_DOC_RECEIPT 3
#define LIBFPTR_FN_DOC_BSO 4
#define LIBFPTR_FN_DOC_CLOSE_SHIFT 5
#define LIBFPTR_FN_DOC_CLOSE_FN 6
#define LIBFPTR_FN_DOC_OPERATOR_CONFIRMATION 7
#define LIBFPTR_FN_DOC_REREGISTRATION 11
#define LIBFPTR_FN_DOC_EXCHANGE_STATUS 21
#define LIBFPTR_FN_DOC_CORRECTION 31
#define LIBFPTR_FN_DOC_BSO_CORRECTION 41
#define LIBFPTR_UCF_CALC_SUMS 1
#define LIBFPTR_UCF_CALC_QUANTITIES 2
#define LIBFPTR_UCF_CALC_SUMS_OTHERS 4
#define LIBFPTR_UCF_CALC_QUANTITIES_OTHERS 8
#define LIBFPTR_UC_OTHERS 4294967295

enum libfptr_param
{
    LIBFPTR_PARAM_TEXT = 65536,
    LIBFPTR_PARAM_TEXT_WRAP = 65537,
    LIBFPTR_PARAM_ALIGNMENT = 65538,
    LIBFPTR_PARAM_FONT = 65539,
    LIBFPTR_PARAM_FONT_DOUBLE_WIDTH = 65540,
    LIBFPTR_PARAM_FONT_DOUBLE_HEIGHT = 65541,
    LIBFPTR_PARAM_LINESPACING = 65542,
    LIBFPTR_PARAM_BRIGHTNESS = 65543,
    LIBFPTR_PARAM_MODEL = 65544,
    LIBFPTR_PARAM_RECEIPT_TYPE = 65545,
    LIBFPTR_PARAM_REPORT_TYPE = 65546,
    LIBFPTR_PARAM_MODE = 65547,
    LIBFPTR_PARAM_EXTERNAL_DEVICE_TYPE = 65548,
    LIBFPTR_PARAM_EXTERNAL_DEVICE_DATA = 65549,
    LIBFPTR_PARAM_FREQUENCY = 65550,
    LIBFPTR_PARAM_DURATION = 65551,
    LIBFPTR_PARAM_CUT_TYPE = 65552,
    LIBFPTR_PARAM_DRAWER_ON_TIMEOUT = 65553,
    LIBFPTR_PARAM_DRAWER_OFF_TIMEOUT = 65554,
    LIBFPTR_PARAM_DRAWER_ON_QUANTITY = 65555,
    LIBFPTR_PARAM_TIMEOUT_ENQ = 65556,
    LIBFPTR_PARAM_COMMAND_BUFFER = 65557,
    LIBFPTR_PARAM_ANSWER_BUFFER = 65558,
    LIBFPTR_PARAM_SERIAL_NUMBER = 65559,
    LIBFPTR_PARAM_MANUFACTURER_CODE = 65560,
    LIBFPTR_PARAM_NO_NEED_ANSWER = 65561,
    LIBFPTR_PARAM_INFO_DISCOUNT_SUM = 65562,
    LIBFPTR_PARAM_USE_ONLY_TAX_TYPE = 65563,
    LIBFPTR_PARAM_PAYMENT_TYPE = 65564,
    LIBFPTR_PARAM_PAYMENT_SUM = 65565,
    LIBFPTR_PARAM_REMAINDER = 65566,
    LIBFPTR_PARAM_CHANGE = 65567,
    LIBFPTR_PARAM_DEPARTMENT = 65568,
    LIBFPTR_PARAM_TAX_TYPE = 65569,
    LIBFPTR_PARAM_TAX_SUM = 65570,
    LIBFPTR_PARAM_TAX_MODE = 65571,
    LIBFPTR_PARAM_RECEIPT_ELECTRONICALLY = 65572,
    LIBFPTR_PARAM_USER_PASSWORD = 65573,
    LIBFPTR_PARAM_SCALE = 65574,
    LIBFPTR_PARAM_LEFT_MARGIN = 65575,
    LIBFPTR_PARAM_BARCODE = 65576,
    LIBFPTR_PARAM_BARCODE_TYPE = 65577,
    LIBFPTR_PARAM_BARCODE_PRINT_TEXT = 65578,
    LIBFPTR_PARAM_BARCODE_VERSION = 65579,
    LIBFPTR_PARAM_BARCODE_CORRECTION = 65580,
    LIBFPTR_PARAM_BARCODE_COLUMNS = 65581,
    LIBFPTR_PARAM_BARCODE_INVERT = 65582,
    LIBFPTR_PARAM_HEIGHT = 65583,
    LIBFPTR_PARAM_WIDTH = 65584,
    LIBFPTR_PARAM_FILENAME = 65585,
    LIBFPTR_PARAM_PICTURE_NUMBER = 65586,
    LIBFPTR_PARAM_DATA_TYPE = 65587,
    LIBFPTR_PARAM_OPERATOR_ID = 65588,
    LIBFPTR_PARAM_LOGICAL_NUMBER = 65589,
    LIBFPTR_PARAM_DATE_TIME = 65590,
    LIBFPTR_PARAM_FISCAL = 65591,
    LIBFPTR_PARAM_SHIFT_STATE = 65592,
    LIBFPTR_PARAM_CASHDRAWER_OPENED = 65593,
    LIBFPTR_PARAM_RECEIPT_PAPER_PRESENT = 65594,
    LIBFPTR_PARAM_COVER_OPENED = 65595,
    LIBFPTR_PARAM_SUBMODE = 65596,
    LIBFPTR_PARAM_RECEIPT_NUMBER = 65597,
    LIBFPTR_PARAM_DOCUMENT_NUMBER = 65598,
    LIBFPTR_PARAM_SHIFT_NUMBER = 65599,
    LIBFPTR_PARAM_RECEIPT_SUM = 65600,
    LIBFPTR_PARAM_RECEIPT_LINE_LENGTH = 65601,
    LIBFPTR_PARAM_RECEIPT_LINE_LENGTH_PIX = 65602,
    LIBFPTR_PARAM_MODEL_NAME = 65603,
    LIBFPTR_PARAM_UNIT_VERSION = 65604,
    LIBFPTR_PARAM_PRINTER_CONNECTION_LOST = 65605,
    LIBFPTR_PARAM_PRINTER_ERROR = 65606,
    LIBFPTR_PARAM_CUT_ERROR = 65607,
    LIBFPTR_PARAM_PRINTER_OVERHEAT = 65608,
    LIBFPTR_PARAM_UNIT_TYPE = 65609,
    LIBFPTR_PARAM_LICENSE_NUMBER = 65610,
    LIBFPTR_PARAM_LICENSE_ENTERED = 65611,
    LIBFPTR_PARAM_LICENSE = 65612,
    LIBFPTR_PARAM_SUM = 65613,
    LIBFPTR_PARAM_COUNT = 65614,
    LIBFPTR_PARAM_COUNTER_TYPE = 65615,
    LIBFPTR_PARAM_STEP_COUNTER_TYPE = 65616,
    LIBFPTR_PARAM_ERROR_TAG_NUMBER = 65617,
    LIBFPTR_PARAM_TABLE = 65618,
    LIBFPTR_PARAM_ROW = 65619,
    LIBFPTR_PARAM_FIELD = 65620,
    LIBFPTR_PARAM_FIELD_VALUE = 65621,
    LIBFPTR_PARAM_FN_DATA_TYPE = 65622,
    LIBFPTR_PARAM_TAG_NUMBER = 65623,
    LIBFPTR_PARAM_TAG_VALUE = 65624,
    LIBFPTR_PARAM_DOCUMENTS_COUNT = 65625,
    LIBFPTR_PARAM_FISCAL_SIGN = 65626,
    LIBFPTR_PARAM_DEVICE_FFD_VERSION = 65627,
    LIBFPTR_PARAM_FN_FFD_VERSION = 65628,
    LIBFPTR_PARAM_FFD_VERSION = 65629,
    LIBFPTR_PARAM_CHECK_SUM = 65630,
    LIBFPTR_PARAM_COMMODITY_NAME = 65631,
    LIBFPTR_PARAM_PRICE = 65632,
    LIBFPTR_PARAM_QUANTITY = 65633,
    LIBFPTR_PARAM_POSITION_SUM = 65634,
    LIBFPTR_PARAM_FN_TYPE = 65635,
    LIBFPTR_PARAM_FN_VERSION = 65636,
    LIBFPTR_PARAM_REGISTRATIONS_REMAIN = 65637,
    LIBFPTR_PARAM_REGISTRATIONS_COUNT = 65638,
    LIBFPTR_PARAM_NO_ERROR_IF_NOT_SUPPORTED = 65639,
    LIBFPTR_PARAM_OFD_EXCHANGE_STATUS = 65640,
    LIBFPTR_PARAM_FN_ERROR_DATA = 65641,
    LIBFPTR_PARAM_FN_ERROR_CODE = 65642,
    LIBFPTR_PARAM_ENVD_MODE = 65643,
    LIBFPTR_PARAM_DOCUMENT_CLOSED = 65644,
    LIBFPTR_PARAM_JSON_DATA = 65645,
    LIBFPTR_PARAM_COMMAND_SUBSYSTEM = 65646,
    LIBFPTR_PARAM_FN_OPERATION_TYPE = 65647,
    LIBFPTR_PARAM_FN_STATE = 65648,
    LIBFPTR_PARAM_ENVD_MODE_ENABLED = 65649,
    LIBFPTR_PARAM_SETTING_ID = 65650,
    LIBFPTR_PARAM_SETTING_VALUE = 65651,
    LIBFPTR_PARAM_MAPPING_KEY = 65652,
    LIBFPTR_PARAM_MAPPING_VALUE = 65653,
    LIBFPTR_PARAM_COMMODITY_PIECE = 65654,
    LIBFPTR_PARAM_POWER_SOURCE_TYPE = 65655,
    LIBFPTR_PARAM_BATTERY_CHARGE = 65656,
    LIBFPTR_PARAM_VOLTAGE = 65657,
    LIBFPTR_PARAM_USE_BATTERY = 65658,
    LIBFPTR_PARAM_BATTERY_CHARGING = 65659,
    LIBFPTR_PARAM_CAN_PRINT_WHILE_ON_BATTERY = 65660,
    LIBFPTR_PARAM_MAC_ADDRESS = 65661,
    LIBFPTR_PARAM_FN_FISCAL = 65662,
    LIBFPTR_PARAM_NETWORK_ERROR = 65663,
    LIBFPTR_PARAM_OFD_ERROR = 65664,
    LIBFPTR_PARAM_FN_ERROR = 65665,
    LIBFPTR_PARAM_COMMAND_CODE = 65666,
    LIBFPTR_PARAM_PRINTER_TEMPERATURE = 65667,
    LIBFPTR_PARAM_RECORDS_TYPE = 65668,
    LIBFPTR_PARAM_OFD_FISCAL_SIGN = 65669,
    LIBFPTR_PARAM_HAS_OFD_TICKET = 65670,
    LIBFPTR_PARAM_NO_SERIAL_NUMBER = 65671,
    LIBFPTR_PARAM_RTC_FAULT = 65672,
    LIBFPTR_PARAM_SETTINGS_FAULT = 65673,
    LIBFPTR_PARAM_COUNTERS_FAULT = 65674,
    LIBFPTR_PARAM_USER_MEMORY_FAULT = 65675,
    LIBFPTR_PARAM_SERVICE_COUNTERS_FAULT = 65676,
    LIBFPTR_PARAM_ATTRIBUTES_FAULT = 65677,
    LIBFPTR_PARAM_FN_FAULT = 65678,
    LIBFPTR_PARAM_INVALID_FN = 65679,
    LIBFPTR_PARAM_HARD_FAULT = 65680,
    LIBFPTR_PARAM_MEMORY_MANAGER_FAULT = 65681,
    LIBFPTR_PARAM_SCRIPTS_FAULT = 65682,
    LIBFPTR_PARAM_FULL_RESET = 65683,
    LIBFPTR_PARAM_WAIT_FOR_REBOOT = 65684,
    LIBFPTR_PARAM_SCALE_PERCENT = 65685,
    LIBFPTR_PARAM_FN_NEED_REPLACEMENT = 65686,
    LIBFPTR_PARAM_FN_RESOURCE_EXHAUSTED = 65687,
    LIBFPTR_PARAM_FN_MEMORY_OVERFLOW = 65688,
    LIBFPTR_PARAM_FN_OFD_TIMEOUT = 65689,
    LIBFPTR_PARAM_FN_CRITICAL_ERROR = 65690,
    LIBFPTR_PARAM_OFD_MESSAGE_READ = 65691,
    LIBFPTR_PARAM_DEVICE_MIN_FFD_VERSION = 65692,
    LIBFPTR_PARAM_DEVICE_MAX_FFD_VERSION = 65693,
    LIBFPTR_PARAM_DEVICE_UPTIME = 65694,
    LIBFPTR_PARAM_NOMENCLATURE_TYPE = 65695,
    LIBFPTR_PARAM_GTIN = 65696,
    LIBFPTR_PARAM_FN_DOCUMENT_TYPE = 65697,
    LIBFPTR_PARAM_NETWORK_ERROR_TEXT = 65698,
    LIBFPTR_PARAM_FN_ERROR_TEXT = 65699,
    LIBFPTR_PARAM_OFD_ERROR_TEXT = 65700,
    LIBFPTR_PARAM_USER_SCRIPT_ID = 65701,
    LIBFPTR_PARAM_USER_SCRIPT_PARAMETER = 65702,
    LIBFPTR_PARAM_USER_MEMORY_OPERATION = 65703,
    LIBFPTR_PARAM_USER_MEMORY_DATA = 65704,
    LIBFPTR_PARAM_USER_MEMORY_STRING = 65705,
    LIBFPTR_PARAM_USER_MEMORY_ADDRESS = 65706,
    LIBFPTR_PARAM_FN_PRESENT = 65707,
    LIBFPTR_PARAM_BLOCKED = 65708,
    LIBFPTR_PARAM_DOCUMENT_PRINTED = 65709,
    LIBFPTR_PARAM_DISCOUNT_SUM = 65710,
    LIBFPTR_PARAM_SURCHARGE_SUM = 65711,
    LIBFPTR_PARAM_LK_USER_CODE = 65712,
    LIBFPTR_PARAM_LICENSE_COUNT = 65713,
    LIBFPTR_PARAM_DEFER = 65714,
    LIBFPTR_PARAM_CAP_54FZ = 65715,
    LIBFPTR_PARAM_CAP_MANUAL_CLICHE_CONTROL = 65716,
    LIBFPTR_PARAM_CAP_PAYMENTS_COUNT = 65717,
    LIBFPTR_PARAM_FIRMWARE_CHUNK_SIZE = 65718,
    LIBFPTR_PARAM_FIRMWARE_CHUNK_DATA = 65719,
    LIBFPTR_PARAM_FN_FLAGS = 65720,
    LIBFPTR_PARAM_PRINT_FOOTER = 65721,
    LIBFPTR_PARAM_PUBLIC_KEY = 65722,
    LIBFPTR_PARAM_MAGIC_NUMBER = 65723,
    LIBFPTR_PARAM_SIGN = 65724,
    LIBFPTR_PARAM_SOFT_NAME = 65725,
    LIBFPTR_PARAM_SESSION_CODE = 65726,
    LIBFPTR_PARAM_ETHERNET_CONFIG_TIMEOUT = 65727,
    LIBFPTR_PARAM_ETHERNET_DHCP = 65728,
    LIBFPTR_PARAM_ETHERNET_IP = 65729,
    LIBFPTR_PARAM_ETHERNET_MASK = 65730,
    LIBFPTR_PARAM_ETHERNET_GATEWAY = 65731,
    LIBFPTR_PARAM_ETHERNET_PORT = 65732,
    LIBFPTR_PARAM_ETHERNET_DNS_IP = 65733,
    LIBFPTR_PARAM_ETHERNET_DNS_STATIC = 65734,
    LIBFPTR_PARAM_STORE_IN_JOURNAL = 65735,
    LIBFPTR_PARAM_NEW_PLATFORM = 65736,
    LIBFPTR_PARAM_UNIT_RELEASE_VERSION = 65737,
    LIBFPTR_PARAM_USE_VAT18 = 65738,
    LIBFPTR_PARAM_TAG_NAME = 65739,
    LIBFPTR_PARAM_TAG_TYPE = 65740,
    LIBFPTR_PARAM_TAG_IS_COMPLEX = 65741,
    LIBFPTR_PARAM_TAG_IS_REPEATABLE = 65742,
    LIBFPTR_PARAM_SHIFT_AUTO_OPENED = 65743,
    LIBFPTR_PARAM_CONTAINER_FIRMWARE_VERSION = 65744,
    LIBFPTR_PARAM_CONTAINER_CONFIGURATION_VERSION = 65745,
    LIBFPTR_PARAM_CONTAINER_BOOTLOADER_VERSION = 65746,
    LIBFPTR_PARAM_CONTAINER_SCRIPTS_VERSION = 65747,
    LIBFPTR_PARAM_PAPER_NEAR_END = 65748,
    LIBFPTR_PARAM_REPORT_ELECTRONICALLY = 65749,
    LIBFPTR_PARAM_ACTIVATION_METHOD = 65750,
    LIBFPTR_PARAM_KEYS = 65751,
    LIBFPTR_PARAM_UIN = 65752,
    LIBFPTR_PARAM_VERSION = 65753,
    LIBFPTR_PARAM_PUBLIC_KEY_SIGN = 65754,
    LIBFPTR_PARAM_CAP_DISABLE_PRINT_REPORTS = 65755,
    LIBFPTR_PARAM_REGISTRATION_NUMBER = 65756,
    LIBFPTR_PARAM_PIXEL_BUFFER = 65757,
    LIBFPTR_PARAM_REPEAT_NUMBER = 65758,
    LIBFPTR_PARAM_FIELD_TYPE = 65759,
    LIBFPTR_PARAM_MARKING_CODE = 65760,
    LIBFPTR_PARAM_CONTAINER_DIRECT_BOOT_VERSION = 65761,
    LIBFPTR_PARAM_SCRIPT_NAME = 65762,
    LIBFPTR_PARAM_SCRIPT_HASH = 65763,
    LIBFPTR_PARAM_RECORDS_ID = 65764,
    LIBFPTR_PARAM_USER_SCRIPT_RESULT_1 = 65765,
    LIBFPTR_PARAM_USER_SCRIPT_RESULT_2 = 65766,
    LIBFPTR_PARAM_USER_SCRIPT_RESULT_3 = 65767,
    LIBFPTR_PARAM_USER_SCRIPT_RESULT_4 = 65768,
    LIBFPTR_PARAM_USER_SCRIPT_RESULT_5 = 65769,
    LIBFPTR_PARAM_IS_USER_SCRIPT = 65770,
    LIBFPTR_PARAM_DOCUMENT_NUMBER_END = 65771,
    LIBFPTR_PARAM_SHIFT_NUMBER_END = 65772,
    LIBFPTR_PARAM_SCRIPT_CODE = 65773,
    LIBFPTR_PARAM_SCRIPT_RESULT = 65774,
    LIBFPTR_PARAM_SCRIPT_TYPE = 65775,
    LIBFPTR_PARAM_WIFI_CONFIG_TIMEOUT = 65776,
    LIBFPTR_PARAM_WIFI_DHCP = 65777,
    LIBFPTR_PARAM_WIFI_IP = 65778,
    LIBFPTR_PARAM_WIFI_MASK = 65779,
    LIBFPTR_PARAM_WIFI_GATEWAY = 65780,
    LIBFPTR_PARAM_WIFI_PORT = 65781,
    LIBFPTR_PARAM_UC_VERSION = 65782,
    LIBFPTR_PARAM_UC_AVAILABLE_MEMORY = 65783,
    LIBFPTR_PARAM_UC_USED_MEMORY_BY_SUMS = 65784,
    LIBFPTR_PARAM_UC_USED_MEMORY_BY_QUANTITIES = 65785,
    LIBFPTR_PARAM_UC_LAYER_1 = 65786,
    LIBFPTR_PARAM_UC_FLAGS_1 = 65787,
    LIBFPTR_PARAM_UC_MASK_1 = 65788,
    LIBFPTR_PARAM_UC_LAYER_VALUE_1 = 65789,
    LIBFPTR_PARAM_UC_LAYER_2 = 65790,
    LIBFPTR_PARAM_UC_FLAGS_2 = 65791,
    LIBFPTR_PARAM_UC_MASK_2 = 65792,
    LIBFPTR_PARAM_UC_LAYER_VALUE_2 = 65793,
    LIBFPTR_PARAM_UC_LAYER_3 = 65794,
    LIBFPTR_PARAM_UC_FLAGS_3 = 65795,
    LIBFPTR_PARAM_UC_MASK_3 = 65796,
    LIBFPTR_PARAM_UC_LAYER_VALUE_3 = 65797,
    LIBFPTR_PARAM_UC_LAYER_4 = 65798,
    LIBFPTR_PARAM_UC_FLAGS_4 = 65799,
    LIBFPTR_PARAM_UC_MASK_4 = 65800,
    LIBFPTR_PARAM_UC_LAYER_VALUE_4 = 65801,
    LIBFPTR_PARAM_RECEIPTS_COUNT = 65802,
    LIBFPTR_PARAM_PAYMENTS_SUM_CASH = 65803,
    LIBFPTR_PARAM_PAYMENTS_SUM_ELECTRONICALLY = 65804,
    LIBFPTR_PARAM_PAYMENTS_SUM_PREPAID = 65805,
    LIBFPTR_PARAM_PAYMENTS_SUM_CREDIT = 65806,
    LIBFPTR_PARAM_PAYMENTS_SUM_OTHER = 65807,
    LIBFPTR_PARAM_TAXES_SUM_VAT20 = 65808,
    LIBFPTR_PARAM_TAXES_SUM_VAT120 = 65809,
    LIBFPTR_PARAM_TAXES_SUM_VAT10 = 65810,
    LIBFPTR_PARAM_TAXES_SUM_VAT110 = 65811,
    LIBFPTR_PARAM_TAXES_SUM_VAT0 = 65812,
    LIBFPTR_PARAM_TAXES_SUM_NO = 65813,
    LIBFPTR_PARAM_CORRECTIONS_COUNT = 65814,
    LIBFPTR_PARAM_CORRECTIONS_SUM = 65815,
    LIBFPTR_PARAM_FN_COUNTERS_TYPE = 65816,
    LIBFPTR_PARAM_FN_DAYS_REMAIN = 65817,
    LIBFPTR_PARAM_FREE_MEMORY = 65818,
    LIBFPTR_PARAM_FN_MAX_FFD_VERSION = 65819,
    LIBFPTR_PARAM_RECEIPTS_SUM = 65820,
    LIBFPTR_PARAM_LICENSE_NAME = 65821,
};

enum libfptr_error
{
    LIBFPTR_OK = 0,
    LIBFPTR_ERROR_CONNECTION_DISABLED = 1,
    LIBFPTR_ERROR_NO_CONNECTION = 2,
    LIBFPTR_ERROR_PORT_BUSY = 3,
    LIBFPTR_ERROR_PORT_NOT_AVAILABLE = 4,
    LIBFPTR_ERROR_INCORRECT_DATA = 5,
    LIBFPTR_ERROR_INTERNAL = 6,
    LIBFPTR_ERROR_UNSUPPORTED_CAST = 7,
    LIBFPTR_ERROR_NO_REQUIRED_PARAM = 8,
    LIBFPTR_ERROR_INVALID_SETTINGS = 9,
    LIBFPTR_ERROR_NOT_CONFIGURED = 10,
    LIBFPTR_ERROR_NOT_SUPPORTED = 11,
    LIBFPTR_ERROR_INVALID_MODE = 12,
    LIBFPTR_ERROR_INVALID_PARAM = 13,
    LIBFPTR_ERROR_NOT_LOADED = 14,
    LIBFPTR_ERROR_UNKNOWN = 15,
    LIBFPTR_ERROR_INVALID_SUM = 16,
    LIBFPTR_ERROR_INVALID_QUANTITY = 17,
    LIBFPTR_ERROR_CASH_COUNTER_OVERFLOW = 18,
    LIBFPTR_ERROR_LAST_OPERATION_STORNO_DENIED = 19,
    LIBFPTR_ERROR_STORNO_BY_CODE_DENIED = 20,
    LIBFPTR_ERROR_LAST_OPERATION_NOT_REPEATABLE = 21,
    LIBFPTR_ERROR_DISCOUNT_NOT_REPEATABLE = 22,
    LIBFPTR_ERROR_DISCOUNT_DENIED = 23,
    LIBFPTR_ERROR_INVALID_COMMODITY_CODE = 24,
    LIBFPTR_ERROR_INVALID_COMMODITY_BARCODE = 25,
    LIBFPTR_ERROR_INVALID_COMMAND_FORMAT = 26,
    LIBFPTR_ERROR_INVALID_COMMAND_LENGTH = 27,
    LIBFPTR_ERROR_BLOCKED_IN_DATE_INPUT_MODE = 28,
    LIBFPTR_ERROR_NEED_DATE_ACCEPT = 29,
    LIBFPTR_ERROR_NO_MORE_DATA = 30,
    LIBFPTR_ERROR_NO_ACCEPT_OR_CANCEL = 31,
    LIBFPTR_ERROR_BLOCKED_BY_REPORT_INTERRUPTION = 32,
    LIBFPTR_ERROR_DISABLE_CASH_CONTROL_DENIED = 33,
    LIBFPTR_ERROR_MODE_BLOCKED = 34,
    LIBFPTR_ERROR_CHECK_DATE_TIME = 35,
    LIBFPTR_ERROR_DATE_TIME_LESS_THAN_FS = 36,
    LIBFPTR_ERROR_CLOSE_ARCHIVE_DENIED = 37,
    LIBFPTR_ERROR_COMMODITY_NOT_FOUND = 38,
    LIBFPTR_ERROR_WEIGHT_BARCODE_WITH_INVALID_QUANTITY = 39,
    LIBFPTR_ERROR_RECEIPT_BUFFER_OVERFLOW = 40,
    LIBFPTR_ERROR_QUANTITY_TOO_FEW = 41,
    LIBFPTR_ERROR_STORNO_TOO_MUCH = 42,
    LIBFPTR_ERROR_BLOCKED_COMMODITY_NOT_FOUND = 43,
    LIBFPTR_ERROR_NO_PAPER = 44,
    LIBFPTR_ERROR_COVER_OPENED = 45,
    LIBFPTR_ERROR_PRINTER_FAULT = 46,
    LIBFPTR_ERROR_MECHANICAL_FAULT = 47,
    LIBFPTR_ERROR_INVALID_RECEIPT_TYPE = 48,
    LIBFPTR_ERROR_INVALID_UNIT_TYPE = 49,
    LIBFPTR_ERROR_NO_MEMORY = 50,
    LIBFPTR_ERROR_PICTURE_NOT_FOUND = 51,
    LIBFPTR_ERROR_NONCACH_PAYMENTS_TOO_MUCH = 52,
    LIBFPTR_ERROR_RETURN_DENIED = 53,
    LIBFPTR_ERROR_PAYMENTS_OVERFLOW = 54,
    LIBFPTR_ERROR_BUSY = 55,
    LIBFPTR_ERROR_GSM = 56,
    LIBFPTR_ERROR_INVALID_DISCOUNT = 57,
    LIBFPTR_ERROR_OPERATION_AFTER_DISCOUNT_DENIED = 58,
    LIBFPTR_ERROR_INVALID_DEPARTMENT = 59,
    LIBFPTR_ERROR_INVALID_PAYMENT_TYPE = 60,
    LIBFPTR_ERROR_MULTIPLICATION_OVERFLOW = 61,
    LIBFPTR_ERROR_DENIED_BY_SETTINGS = 62,
    LIBFPTR_ERROR_TOTAL_OVERFLOW = 63,
    LIBFPTR_ERROR_DENIED_IN_ANNULATION_RECEIPT = 64,
    LIBFPTR_ERROR_JOURNAL_OVERFLOW = 65,
    LIBFPTR_ERROR_NOT_FULLY_PAID = 66,
    LIBFPTR_ERROR_DENIED_IN_RETURN_RECEIPT = 67,
    LIBFPTR_ERROR_SHIFT_EXPIRED = 68,
    LIBFPTR_ERROR_DENIED_IN_SELL_RECEIPT = 69,
    LIBFPTR_ERROR_FISCAL_MEMORY_OVERFLOW = 70,
    LIBFPTR_ERROR_INVALID_PASSWORD = 71,
    LIBFPTR_ERROR_JOURNAL_BUSY = 72,
    LIBFPTR_ERROR_DENIED_IN_CLOSED_SHIFT = 73,
    LIBFPTR_ERROR_INVALID_TABLE_NUMBER = 74,
    LIBFPTR_ERROR_INVALID_ROW_NUMBER = 75,
    LIBFPTR_ERROR_INVALID_FIELD_NUMBER = 76,
    LIBFPTR_ERROR_INVALID_DATE_TIME = 77,
    LIBFPTR_ERROR_INVALID_STORNO_SUM = 78,
    LIBFPTR_ERROR_CHANGE_CALCULATION = 79,
    LIBFPTR_ERROR_NO_CASH = 80,
    LIBFPTR_ERROR_DENIED_IN_CLOSED_RECEIPT = 81,
    LIBFPTR_ERROR_DENIED_IN_OPENED_RECEIPT = 82,
    LIBFPTR_ERROR_DENIED_IN_OPENED_SHIFT = 83,
    LIBFPTR_ERROR_SERIAL_NUMBER_ALREADY_ENTERED = 84,
    LIBFPTR_ERROR_TOO_MUCH_REREGISTRATIONS = 85,
    LIBFPTR_ERROR_INVALID_SHIFT_NUMBER = 86,
    LIBFPTR_ERROR_INVALID_SERIAL_NUMBER = 87,
    LIBFPTR_ERROR_INVALID_RNM_VATIN = 88,
    LIBFPTR_ERROR_FISCAL_PRINTER_NOT_ACTIVATED = 89,
    LIBFPTR_ERROR_SERIAL_NUMBER_NOT_ENTERED = 90,
    LIBFPTR_ERROR_NO_MORE_REPORTS = 91,
    LIBFPTR_ERROR_MODE_NOT_ACTIVATED = 92,
    LIBFPTR_ERROR_RECORD_NOT_FOUND_IN_JOURNAL = 93,
    LIBFPTR_ERROR_INVALID_LICENSE = 94,
    LIBFPTR_ERROR_NEED_FULL_RESET = 95,
    LIBFPTR_ERROR_DENIED_BY_LICENSE = 96,
    LIBFPTR_ERROR_DISCOUNT_CANCELLATION_DENIED = 97,
    LIBFPTR_ERROR_CLOSE_RECEIPT_DENIED = 98,
    LIBFPTR_ERROR_INVALID_ROUTE_NUMBER = 99,
    LIBFPTR_ERROR_INVALID_START_ZONE_NUMBER = 100,
    LIBFPTR_ERROR_INVALID_END_ZONE_NUMBER = 101,
    LIBFPTR_ERROR_INVALID_RATE_TYPE = 102,
    LIBFPTR_ERROR_INVALID_RATE = 103,
    LIBFPTR_ERROR_FISCAL_MODULE_EXCHANGE = 104,
    LIBFPTR_ERROR_NEED_TECHNICAL_SUPPORT = 105,
    LIBFPTR_ERROR_SHIFT_NUMBERS_DID_NOT_MATCH = 106,
    LIBFPTR_ERROR_DEVICE_NOT_FOUND = 107,
    LIBFPTR_ERROR_EXTERNAL_DEVICE_CONNECTION = 108,
    LIBFPTR_ERROR_DISPENSER_INVALID_STATE = 109,
    LIBFPTR_ERROR_INVALID_POSITIONS_COUNT = 110,
    LIBFPTR_ERROR_DISPENSER_INVALID_NUMBER = 111,
    LIBFPTR_ERROR_INVALID_DIVIDER = 112,
    LIBFPTR_ERROR_FN_ACTIVATION_DENIED = 113,
    LIBFPTR_ERROR_PRINTER_OVERHEAT = 114,
    LIBFPTR_ERROR_FN_EXCHANGE = 115,
    LIBFPTR_ERROR_FN_INVALID_FORMAT = 116,
    LIBFPTR_ERROR_FN_INVALID_STATE = 117,
    LIBFPTR_ERROR_FN_FAULT = 118,
    LIBFPTR_ERROR_FN_CRYPTO_FAULT = 119,
    LIBFPTR_ERROR_FN_EXPIRED = 120,
    LIBFPTR_ERROR_FN_OVERFLOW = 121,
    LIBFPTR_ERROR_FN_INVALID_DATE_TIME = 122,
    LIBFPTR_ERROR_FN_NO_MORE_DATA = 123,
    LIBFPTR_ERROR_FN_TOTAL_OVERFLOW = 124,
    LIBFPTR_ERROR_BUFFER_OVERFLOW = 125,
    LIBFPTR_ERROR_PRINT_SECOND_COPY_DENIED = 126,
    LIBFPTR_ERROR_NEED_RESET_JOURNAL = 127,
    LIBFPTR_ERROR_TAX_SUM_TOO_MUCH = 128,
    LIBFPTR_ERROR_TAX_ON_LAST_OPERATION_DENIED = 129,
    LIBFPTR_ERROR_INVALID_FN_NUMBER = 130,
    LIBFPTR_ERROR_TAX_CANCEL_DENIED = 131,
    LIBFPTR_ERROR_LOW_BATTERY = 132,
    LIBFPTR_ERROR_FN_INVALID_COMMAND = 133,
    LIBFPTR_ERROR_FN_COMMAND_OVERFLOW = 134,
    LIBFPTR_ERROR_FN_NO_TRANSPORT_CONNECTION = 135,
    LIBFPTR_ERROR_FN_CRYPTO_HAS_EXPIRED = 136,
    LIBFPTR_ERROR_FN_RESOURCE_HAS_EXPIRED = 137,
    LIBFPTR_ERROR_INVALID_MESSAGE_FROM_OFD = 138,
    LIBFPTR_ERROR_FN_HAS_NOT_SEND_DOCUMENTS = 139,
    LIBFPTR_ERROR_FN_TIMEOUT = 140,
    LIBFPTR_ERROR_FN_SHIFT_EXPIRED = 141,
    LIBFPTR_ERROR_FN_INVALID_TIME_DIFFERENCE = 142,
    LIBFPTR_ERROR_INVALID_TAXATION_TYPE = 143,
    LIBFPTR_ERROR_INVALID_TAX_TYPE = 144,
    LIBFPTR_ERROR_INVALID_COMMODITY_PAYMENT_TYPE = 145,
    LIBFPTR_ERROR_INVALID_COMMODITY_CODE_TYPE = 146,
    LIBFPTR_ERROR_EXCISABLE_COMMODITY_DENIED = 147,
    LIBFPTR_ERROR_FISCAL_PROPERTY_WRITE = 148,
    LIBFPTR_ERROR_INVALID_COUNTER_TYPE = 149,
    LIBFPTR_ERROR_CUTTER_FAULT = 150,
    LIBFPTR_ERROR_REPORT_INTERRUPTED = 151,
    LIBFPTR_ERROR_INVALID_LEFT_MARGIN = 152,
    LIBFPTR_ERROR_INVALID_ALIGNMENT = 153,
    LIBFPTR_ERROR_INVALID_TAX_MODE = 154,
    LIBFPTR_ERROR_FILE_NOT_FOUND = 155,
    LIBFPTR_ERROR_PICTURE_TOO_BIG = 156,
    LIBFPTR_ERROR_INVALID_BARCODE_PARAMS = 157,
    LIBFPTR_ERROR_FISCAL_PROPERTY_DENIED = 158,
    LIBFPTR_ERROR_FN_INTERFACE = 159,
    LIBFPTR_ERROR_DATA_DUPLICATE = 160,
    LIBFPTR_ERROR_NO_REQUIRED_FISCAL_PROPERTY = 161,
    LIBFPTR_ERROR_FN_READ_DOCUMENT = 162,
    LIBFPTR_ERROR_FLOAT_OVERFLOW = 163,
    LIBFPTR_ERROR_INVALID_SETTING_VALUE = 164,
    LIBFPTR_ERROR_HARD_FAULT = 165,
    LIBFPTR_ERROR_FN_NOT_FOUND = 166,
    LIBFPTR_ERROR_INVALID_AGENT_FISCAL_PROPERTY = 167,
    LIBFPTR_ERROR_INVALID_FISCAL_PROPERTY_VALUE_1002_1056 = 168,
    LIBFPTR_ERROR_INVALID_FISCAL_PROPERTY_VALUE_1002_1017 = 169,
    LIBFPTR_ERROR_SCRIPT = 170,
    LIBFPTR_ERROR_INVALID_USER_MEMORY_INDEX = 171,
    LIBFPTR_ERROR_NO_ACTIVE_OPERATOR = 172,
    LIBFPTR_ERROR_REGISTRATION_REPORT_INTERRUPTED = 173,
    LIBFPTR_ERROR_CLOSE_FN_REPORT_INTERRUPTED = 174,
    LIBFPTR_ERROR_OPEN_SHIFT_REPORT_INTERRUPTED = 175,
    LIBFPTR_ERROR_OFD_EXCHANGE_REPORT_INTERRUPTED = 176,
    LIBFPTR_ERROR_CLOSE_RECEIPT_INTERRUPTED = 177,
    LIBFPTR_ERROR_FN_QUERY_INTERRUPTED = 178,
    LIBFPTR_ERROR_RTC_FAULT = 179,
    LIBFPTR_ERROR_MEMORY_FAULT = 180,
    LIBFPTR_ERROR_CHIP_FAULT = 181,
    LIBFPTR_ERROR_TEMPLATES_CORRUPTED = 182,
    LIBFPTR_ERROR_INVALID_MAC_ADDRESS = 183,
    LIBFPTR_ERROR_INVALID_SCRIPT_NUMBER = 184,
    LIBFPTR_ERROR_SCRIPTS_FAULT = 185,
    LIBFPTR_ERROR_INVALID_SCRIPTS_VERSION = 186,
    LIBFPTR_ERROR_INVALID_CLICHE_FORMAT = 187,
    LIBFPTR_ERROR_WAIT_FOR_REBOOT = 188,
    LIBFPTR_ERROR_NO_LICENSE = 189,
    LIBFPTR_ERROR_INVALID_FFD_VERSION = 190,
    LIBFPTR_ERROR_CHANGE_SETTING_DENIED = 191,
    LIBFPTR_ERROR_INVALID_NOMENCLATURE_TYPE = 192,
    LIBFPTR_ERROR_INVALID_GTIN = 193,
    LIBFPTR_ERROR_NEGATIVE_MATH_RESULT = 194,
    LIBFPTR_ERROR_FISCAL_PROPERTIES_COMBINATION = 195,
    LIBFPTR_ERROR_OPERATOR_LOGIN = 196,
    LIBFPTR_ERROR_INVALID_INTERNET_CHANNEL = 197,
    LIBFPTR_ERROR_DATETIME_NOT_SYNCRONIZED = 198,
    LIBFPTR_ERROR_JOURNAL = 199,
    LIBFPTR_ERROR_DENIED_IN_OPENED_DOC = 200,
    LIBFPTR_ERROR_DENIED_IN_CLOSED_DOC = 201,
    LIBFPTR_ERROR_LICENSE_MEMORY_OVERFLOW = 202,
    LIBFPTR_ERROR_NEED_CANCEL_DOCUMENT = 203,
    LIBFPTR_ERROR_REGISTERS_NOT_INITIALIZED = 204,
    LIBFPTR_ERROR_TOTAL_REQUIRED = 205,
    LIBFPTR_ERROR_SETTINGS_FAULT = 206,
    LIBFPTR_ERROR_COUNTERS_FAULT = 207,
    LIBFPTR_ERROR_USER_MEMORY_FAULT = 208,
    LIBFPTR_ERROR_SERVICE_COUNTERS_FAULT = 209,
    LIBFPTR_ERROR_ATTRIBUTES_FAULT = 210,
    LIBFPTR_ERROR_ALREADY_IN_UPDATE_MODE = 211,
    LIBFPTR_ERROR_INVALID_FIRMWARE = 212,
    LIBFPTR_ERROR_INVALID_CHANNEL = 213,
    LIBFPTR_ERROR_INTERFACE_DOWN = 214,
    LIBFPTR_ERROR_INVALID_FISCAL_PROPERTY_VALUE_1212_1030 = 215,
    LIBFPTR_ERROR_INVALID_FISCAL_PROPERTY_VALUE_1214 = 216,
    LIBFPTR_ERROR_INVALID_FISCAL_PROPERTY_VALUE_1212 = 217,
    LIBFPTR_ERROR_SYNC_TIME = 218,
    LIBFPTR_ERROR_VAT18_VAT20_IN_RECEIPT = 219,
    LIBFPTR_ERROR_PICTURE_NOT_CLOSED = 220,
    LIBFPTR_ERROR_INTERFACE_BUSY = 221,
    LIBFPTR_ERROR_INVALID_PICTURE_NUMBER = 222,
    LIBFPTR_ERROR_INVALID_CONTAINER = 223,
    LIBFPTR_ERROR_ARCHIVE_CLOSED = 224,
    LIBFPTR_ERROR_NEED_REGISTRATION = 225,
    LIBFPTR_ERROR_DENIED_DURING_UPDATE = 226,
    LIBFPTR_ERROR_INVALID_TOTAL = 227,
    LIBFPTR_ERROR_MARKING_CODE_CONFLICT = 228,
    LIBFPTR_ERROR_INVALID_RECORDS_ID = 229,
    LIBFPTR_ERROR_INVALID_SIGNATURE = 230,
    LIBFPTR_ERROR_INVALID_EXCISE_SUM = 231,
    LIBFPTR_ERROR_NO_DOCUMENTS_FOUND_IN_JOURNAL = 232,
    LIBFPTR_ERROR_INVALID_SCRIPT_TYPE = 233,
    LIBFPTR_ERROR_INVALID_SCRIPT_NAME = 234,
    LIBFPTR_ERROR_INVALID_POSITIONS_COUNT_WITH_1162 = 235,
    LIBFPTR_ERROR_INVALID_UC_COUNTER = 236,
    LIBFPTR_ERROR_INVALID_UC_TAG = 237,
    LIBFPTR_ERROR_INVALID_UC_IDX = 238,
    LIBFPTR_ERROR_INVALID_UC_EMPTY_FILTER = 239,
    LIBFPTR_ERROR_INVALID_UC_CONFIG = 240,
    LIBFPTR_ERROR_CONNECTION_LOST = 241,
};

enum libfptr_json_web_error
{
    LIBFPTR_ERROR_BASE_WEB = 500,
    LIBFPTR_ERROR_RECEIPT_PARSE_ERROR = 501,
    LIBFPTR_ERROR_INTERRUPTED_BY_PREVIOUS_ERRORS = 502,
    LIBFPTR_ERROR_DRIVER_SCRIPT_ERROR = 503,
};

enum libfptr_port
{
    LIBFPTR_PORT_COM = 0,
    LIBFPTR_PORT_USB = 1,
    LIBFPTR_PORT_TCPIP = 2,
    LIBFPTR_PORT_BLUETOOTH = 3,
};

enum libfptr_bits
{
    LIBFPTR_PORT_BITS_7 = 7,
    LIBFPTR_PORT_BITS_8 = 8,
};

enum libfptr_parity
{
    LIBFPTR_PORT_PARITY_NO = 0,
    LIBFPTR_PORT_PARITY_ODD = 1,
    LIBFPTR_PORT_PARITY_EVEN = 2,
    LIBFPTR_PORT_PARITY_MARK = 3,
    LIBFPTR_PORT_PARITY_SPACE = 4,
};

enum libfptr_stopbits
{
    LIBFPTR_PORT_SB_1 = 0,
    LIBFPTR_PORT_SB_1_5 = 1,
    LIBFPTR_PORT_SB_2 = 2,
};

enum libfptr_barcode_type
{
    LIBFPTR_BT_EAN_8 = 0,
    LIBFPTR_BT_EAN_13 = 1,
    LIBFPTR_BT_UPC_A = 2,
    LIBFPTR_BT_UPC_E = 3,
    LIBFPTR_BT_CODE_39 = 4,
    LIBFPTR_BT_CODE_93 = 5,
    LIBFPTR_BT_CODE_128 = 6,
    LIBFPTR_BT_CODABAR = 7,
    LIBFPTR_BT_ITF = 8,
    LIBFPTR_BT_ITF_14 = 9,
    LIBFPTR_BT_GS1_128 = 10,
    LIBFPTR_BT_QR = 11,
    LIBFPTR_BT_PDF417 = 12,
    LIBFPTR_BT_AZTEC = 13,
    LIBFPTR_BT_CODE_39_EXTENDED = 14,
};

enum libfptr_barcode_correction
{
    LIBFPTR_BC_DEFAULT = 0,
    LIBFPTR_BC_0 = 1,
    LIBFPTR_BC_1 = 2,
    LIBFPTR_BC_2 = 3,
    LIBFPTR_BC_3 = 4,
    LIBFPTR_BC_4 = 5,
    LIBFPTR_BC_5 = 6,
    LIBFPTR_BC_6 = 7,
    LIBFPTR_BC_7 = 8,
    LIBFPTR_BC_8 = 9,
};

enum libfptr_tax_mode
{
    LIBFPTR_TM_POSITION = 0,
    LIBFPTR_TM_UNIT = 1,
};

enum libfptr_step_counter_type
{
    LIBFPTR_SCT_OVERALL = 0,
    LIBFPTR_SCT_FORWARD = 1,
};

enum libfptr_counter_type
{
    LIBFPTR_CT_ROLLUP = 0,
    LIBFPTR_CT_RESETTABLE = 1,
};

enum libfptr_shift_state
{
    LIBFPTR_SS_CLOSED = 0,
    LIBFPTR_SS_OPENED = 1,
    LIBFPTR_SS_EXPIRED = 2,
};

enum libfptr_cut_type
{
    LIBFPTR_CT_FULL = 0,
    LIBFPTR_CT_PART = 1,
};

enum libfptr_alignment
{
    LIBFPTR_ALIGNMENT_LEFT = 0,
    LIBFPTR_ALIGNMENT_CENTER = 1,
    LIBFPTR_ALIGNMENT_RIGHT = 2,
};

enum libfptr_text_wrap
{
    LIBFPTR_TW_NONE = 0,
    LIBFPTR_TW_WORDS = 1,
    LIBFPTR_TW_CHARS = 2,
};

enum libfptr_fn_type
{
    LIBFPTR_FNT_DEBUG = 0,
    LIBFPTR_FNT_RELEASE = 1,
    LIBFPTR_FNT_UNKNOWN = 2,
};

enum libfptr_report_type
{
    LIBFPTR_RT_CLOSE_SHIFT = 0,
    LIBFPTR_RT_X = 1,
    LIBFPTR_RT_LAST_DOCUMENT = 2,
    LIBFPTR_RT_OFD_EXCHANGE_STATUS = 3,
    LIBFPTR_RT_KKT_DEMO = 4,
    LIBFPTR_RT_KKT_INFO = 5,
    LIBFPTR_RT_OFD_TEST = 6,
    LIBFPTR_RT_FN_DOC_BY_NUMBER = 7,
    LIBFPTR_RT_QUANTITY = 8,
    LIBFPTR_RT_DEPARTMENTS = 9,
    LIBFPTR_RT_OPERATORS = 10,
    LIBFPTR_RT_HOURS = 11,
    LIBFPTR_RT_FN_REGISTRATIONS = 12,
    LIBFPTR_RT_FN_SHIFT_TOTAL_COUNTERS = 13,
    LIBFPTR_RT_FN_TOTAL_COUNTERS = 14,
    LIBFPTR_RT_FN_NOT_SENT_DOCUMENTS_COUNTERS = 15,
    LIBFPTR_RT_COMMODITIES_BY_TAXATION_TYPES = 16,
    LIBFPTR_RT_COMMODITIES_BY_DEPARTMENTS = 17,
    LIBFPTR_RT_COMMODITIES_BY_SUMS = 18,
    LIBFPTR_RT_START_SERVICE = 19,
    LIBFPTR_RT_DISCOUNTS = 20,
    LIBFPTR_RT_JOURNAL_DOCUMENT_BY_NUMBERS = 21,
    LIBFPTR_RT_JOURNAL_DOCUMENT_BY_SHIFTS = 22,
};

enum libfptr_payment_type
{
    LIBFPTR_PT_CASH = 0,
    LIBFPTR_PT_ELECTRONICALLY = 1,
    LIBFPTR_PT_PREPAID = 2,
    LIBFPTR_PT_CREDIT = 3,
    LIBFPTR_PT_OTHER = 4,
    LIBFPTR_PT_6 = 5,
    LIBFPTR_PT_7 = 6,
    LIBFPTR_PT_8 = 7,
    LIBFPTR_PT_9 = 8,
    LIBFPTR_PT_10 = 9,
};

enum libfptr_tax_type
{
    LIBFPTR_TAX_DEPARTMENT = 0,
    LIBFPTR_TAX_VAT18 = 1,
    LIBFPTR_TAX_VAT10 = 2,
    LIBFPTR_TAX_VAT118 = 3,
    LIBFPTR_TAX_VAT110 = 4,
    LIBFPTR_TAX_VAT0 = 5,
    LIBFPTR_TAX_NO = 6,
    LIBFPTR_TAX_VAT20 = 7,
    LIBFPTR_TAX_VAT120 = 8,
};

enum libfptr_external_device_type
{
    LIBFPTR_EXTERNAL_DEVICE_DISPLAY = 0,
    LIBFPTR_EXTERNAL_DEVICE_PINPAD = 1,
    LIBFPTR_EXTERNAL_DEVICE_MODEM = 2,
    LIBFPTR_EXTERNAL_DEVICE_BARCODE_SCANNER = 3,
};

enum libfptr_kkt_data_type
{
    LIBFPTR_DT_STATUS = 0,
    LIBFPTR_DT_CASH_SUM = 1,
    LIBFPTR_DT_UNIT_VERSION = 2,
    LIBFPTR_DT_PICTURE_INFO = 3,
    LIBFPTR_DT_LICENSE_ACTIVATED = 4,
    LIBFPTR_DT_REGISTRATIONS_SUM = 5,
    LIBFPTR_DT_REGISTRATIONS_COUNT = 6,
    LIBFPTR_DT_PAYMENT_SUM = 7,
    LIBFPTR_DT_CASHIN_SUM = 8,
    LIBFPTR_DT_CASHIN_COUNT = 9,
    LIBFPTR_DT_CASHOUT_SUM = 10,
    LIBFPTR_DT_CASHOUT_COUNT = 11,
    LIBFPTR_DT_REVENUE = 12,
    LIBFPTR_DT_DATE_TIME = 13,
    LIBFPTR_DT_SHIFT_STATE = 14,
    LIBFPTR_DT_RECEIPT_STATE = 15,
    LIBFPTR_DT_SERIAL_NUMBER = 16,
    LIBFPTR_DT_MODEL_INFO = 17,
    LIBFPTR_DT_RECEIPT_LINE_LENGTH = 18,
    LIBFPTR_DT_CUTTER_RESOURCE = 19,
    LIBFPTR_DT_STEP_RESOURCE = 20,
    LIBFPTR_DT_TERMAL_RESOURCE = 21,
    LIBFPTR_DT_ENVD_MODE = 22,
    LIBFPTR_DT_SHIFT_TAX_SUM = 23,
    LIBFPTR_DT_RECEIPT_TAX_SUM = 24,
    LIBFPTR_DT_NON_NULLABLE_SUM = 25,
    LIBFPTR_DT_RECEIPT_COUNT = 26,
    LIBFPTR_DT_CANCELLATION_COUNT_ALL = 27,
    LIBFPTR_DT_CANCELLATION_SUM = 28,
    LIBFPTR_DT_CANCELLATION_SUM_ALL = 29,
    LIBFPTR_DT_POWER_SOURCE_STATE = 30,
    LIBFPTR_DT_CANCELLATION_COUNT = 31,
    LIBFPTR_DT_NON_NULLABLE_SUM_BY_PAYMENTS = 32,
    LIBFPTR_DT_PRINTER_TEMPERATURE = 33,
    LIBFPTR_DT_FATAL_STATUS = 34,
    LIBFPTR_DT_MAC_ADDRESS = 35,
    LIBFPTR_DT_DEVICE_UPTIME = 36,
    LIBFPTR_DT_RECEIPT_BYTE_COUNT = 37,
    LIBFPTR_DT_DISCOUNT_AND_SURCHARGE_SUM = 38,
    LIBFPTR_DT_LK_USER_CODE = 39,
    LIBFPTR_DT_LAST_SENT_OFD_DOCUMENT_DATE_TIME = 40,
    LIBFPTR_DT_SHORT_STATUS = 41,
    LIBFPTR_DT_PICTURES_ARRAY_INFO = 42,
    LIBFPTR_DT_ETHERNET_INFO = 43,
    LIBFPTR_DT_SCRIPTS_INFO = 44,
    LIBFPTR_DT_SHIFT_TOTALS = 45,
    LIBFPTR_DT_WIFI_INFO = 46,
};

enum libfptr_fn_data_type
{
    LIBFPTR_FNDT_TAG_VALUE = 0,
    LIBFPTR_FNDT_OFD_EXCHANGE_STATUS = 1,
    LIBFPTR_FNDT_FN_INFO = 2,
    LIBFPTR_FNDT_LAST_REGISTRATION = 3,
    LIBFPTR_FNDT_LAST_RECEIPT = 4,
    LIBFPTR_FNDT_LAST_DOCUMENT = 5,
    LIBFPTR_FNDT_SHIFT = 6,
    LIBFPTR_FNDT_FFD_VERSIONS = 7,
    LIBFPTR_FNDT_VALIDITY = 8,
    LIBFPTR_FNDT_REG_INFO = 9,
    LIBFPTR_FNDT_DOCUMENTS_COUNT_IN_SHIFT = 10,
    LIBFPTR_FNDT_ERRORS = 11,
    LIBFPTR_FNDT_TICKET_BY_DOC_NUMBER = 12,
    LIBFPTR_FNDT_DOCUMENT_BY_NUMBER = 13,
    LIBFPTR_FNDT_REGISTRATION_TLV = 14,
    LIBFPTR_FNDT_ERROR_DETAIL = 15,
    LIBFPTR_FNDT_VALIDITY_DAYS = 16,
    LIBFPTR_FNDT_FREE_MEMORY = 17,
    LIBFPTR_FNDT_TOTALS = 18,
};

enum libfptr_unit_type
{
    LIBFPTR_UT_FIRMWARE = 0,
    LIBFPTR_UT_CONFIGURATION = 1,
    LIBFPTR_UT_TEMPLATES = 2,
    LIBFPTR_UT_CONTROL_UNIT = 3,
    LIBFPTR_UT_BOOT = 4,
};

enum libfptr_fn_operation_type
{
    LIBFPTR_FNOP_REGISTRATION = 0,
    LIBFPTR_FNOP_CHANGE_FN = 1,
    LIBFPTR_FNOP_CHANGE_PARAMETERS = 2,
    LIBFPTR_FNOP_CLOSE_ARCHIVE = 3,
};

enum libfptr_ofd_channel
{
    LIBFPTR_OFD_CHANNEL_NONE = 0,
    LIBFPTR_OFD_CHANNEL_USB = 1,
    LIBFPTR_OFD_CHANNEL_PROTO = 2,
};

enum libfptr_power_source_type
{
    LIBFPTR_PST_POWER_SUPPLY = 0,
    LIBFPTR_PST_RTC_BATTERY = 1,
    LIBFPTR_PST_BATTERY = 2,
};

enum libfptr_records_type
{
    LIBFPTR_RT_LAST_DOCUMENT_LINES = 0,
    LIBFPTR_RT_FN_DOCUMENT_TLVS = 1,
    LIBFPTR_RT_EXEC_USER_SCRIPT = 2,
    LIBFPTR_RT_FIRMWARE = 3,
    LIBFPTR_RT_LICENSES = 4,
    LIBFPTR_RT_FN_REGISTRATION_TLVS = 5,
    LIBFPTR_RT_PARSE_COMPLEX_ATTR = 6,
    LIBFPTR_RT_FN_SUM_COUNTERS = 7,
    LIBFPTR_RT_FN_QUANTITY_COUNTERS = 8,
    LIBFPTR_RT_FN_UNSENT_DOCS_COUNTERS = 9,
};

enum libfptr_log_level
{
    LIBFPTR_LOG_ERROR = 0,
    LIBFPTR_LOG_WARN = 1,
    LIBFPTR_LOG_INFO = 2,
    LIBFPTR_LOG_DEBUG = 3,
};

enum libfptr_nomenclature_type
{
    LIBFPTR_NT_FURS = 0,
    LIBFPTR_NT_MEDICINES = 1,
    LIBFPTR_NT_TOBACCO = 2,
    LIBFPTR_NT_SHOES = 3,
};

enum libfptr_user_memory_operation
{
    LIBFPTR_UMO_GET_SIZE = 0,
    LIBFPTR_UMO_READ_DATA = 1,
    LIBFPTR_UMO_WRITE_DATA = 2,
    LIBFPTR_UMO_READ_STRING = 3,
    LIBFPTR_UMO_WRITE_STRING = 4,
    LIBFPTR_UMO_COMMIT = 5,
};

enum libfptr_gui_parent
{
    LIBFPTR_GUI_PARENT_NATIVE = 0,
    LIBFPTR_GUI_PARENT_QT = 1,
};

enum libfptr_defer_type
{
    LIBFPTR_DEFER_NONE = 0,
    LIBFPTR_DEFER_PRE = 1,
    LIBFPTR_DEFER_POST = 2,
    LIBFPTR_DEFER_OVERLAY = 3,
};

enum libfptr_tag_type
{
    LIBFPTR_TAG_TYPE_STLV = 0,
    LIBFPTR_TAG_TYPE_STRING = 1,
    LIBFPTR_TAG_TYPE_ARRAY = 2,
    LIBFPTR_TAG_TYPE_FVLN = 3,
    LIBFPTR_TAG_TYPE_BITS = 4,
    LIBFPTR_TAG_TYPE_BYTE = 5,
    LIBFPTR_TAG_TYPE_VLN = 6,
    LIBFPTR_TAG_TYPE_UINT_16 = 7,
    LIBFPTR_TAG_TYPE_UINT_32 = 8,
    LIBFPTR_TAG_TYPE_UNIX_TIME = 9,
    LIBFPTR_TAG_TYPE_BOOL = 10,
};

enum libfptr_field_type
{
    LIBFPTR_FT_BYTE_ARRAY = 0,
    LIBFPTR_FT_BIN = 1,
    LIBFPTR_FT_BCD = 2,
    LIBFPTR_FT_STRING = 3,
    LIBFPTR_FT_STRING_NULL_TERM = 4,
};

enum libfptr_script_type
{
    LIBFPTR_SCRIPT_EXECUTABLE = 0,
    LIBFPTR_SCRIPT_JSON = 1,
};

enum libfptr_uc_layer
{
    LIBFPTR_UCL_UNUSED = 0,
    LIBFPTR_UCL_RECEIPT_TYPE = 1,
    LIBFPTR_UCL_TAXATION_TYPE = 2,
    LIBFPTR_UCL_TAX_TYPE = 3,
    LIBFPTR_UCL_PRODUCT_TYPE = 4,
    LIBFPTR_UCL_PAYMENT_METHOD = 5,
    LIBFPTR_UCL_USER_3 = 6,
    LIBFPTR_UCL_USER_4 = 7,
    LIBFPTR_UCL_USER_5 = 8,
    LIBFPTR_UCL_USER_6 = 9,
};

enum libfptr_fn_counter_type
{
    LIBFPTR_FNCT_SHIFT = 0,
    LIBFPTR_FNCT_NON_NULLABLE = 1,
};



__attribute__((visibility("default")))
@interface IFptr : NSObject {
}

- (id) init;
- (void) dealloc;
- (NSString *) version;
- (int) logWrite: (NSString *)tag level: (int)level message: (NSString *)message;
- (bool) isOpened;
- (int) errorCode;
- (NSString *) errorDescription;
- (void) resetError;
- (int) setSettings: (NSString *)settings;
- (NSString *) getSettings;
- (void) setSingleSetting: (NSString *)key value: (NSString *)value;
- (NSString *) getSingleSetting: (NSString *)key;
- (void) setParam: (int)param intParam: (uint)value;
- (void) setParam: (int)param boolParam: (bool)value;
- (void) setParam: (int)param doubleParam: (double)value;
- (void) setParam: (int)param NSDataParam: (NSData *)value;
- (void) setParam: (int)param NSDateParam: (NSDate *)value;
- (void) setParam: (int)param NSStringParam: (NSString *)value;
- (void) setNonPrintableParam: (int)param intParam: (uint)value;
- (void) setNonPrintableParam: (int)param boolParam: (bool)value;
- (void) setNonPrintableParam: (int)param doubleParam: (double)value;
- (void) setNonPrintableParam: (int)param NSDataParam: (NSData *)value;
- (void) setNonPrintableParam: (int)param NSDateParam: (NSDate *)value;
- (void) setNonPrintableParam: (int)param NSStringParam: (NSString *)value;
- (void) setUserParam: (int)param intParam: (uint)value;
- (void) setUserParam: (int)param boolParam: (bool)value;
- (void) setUserParam: (int)param doubleParam: (double)value;
- (void) setUserParam: (int)param NSDataParam: (NSData *)value;
- (void) setUserParam: (int)param NSDateParam: (NSDate *)value;
- (void) setUserParam: (int)param NSStringParam: (NSString *)value;
- (uint) getParamInt: (int)param;
- (bool) getParamBool: (int)param;
- (double) getParamDouble: (int)param;
- (NSData *) getParamByteArray: (int)param;
- (NSDate *) getParamDateTime: (int)param;
- (NSString *) getParamString: (int)param;
- (int) applySingleSettings;
- (int) open;
- (int) close;
- (int) resetParams;
- (int) runCommand;
- (int) beep;
- (int) openDrawer;
- (int) cut;
- (int) devicePoweroff;
- (int) deviceReboot;
- (int) openShift;
- (int) resetSummary;
- (int) initDevice;
- (int) queryData;
- (int) cashIncome;
- (int) cashOutcome;
- (int) openReceipt;
- (int) cancelReceipt;
- (int) closeReceipt;
- (int) checkDocumentClosed;
- (int) receiptTotal;
- (int) receiptTax;
- (int) registration;
- (int) payment;
- (int) report;
- (int) printText;
- (int) printCliche;
- (int) beginNonfiscalDocument;
- (int) endNonfiscalDocument;
- (int) printBarcode;
- (int) printPicture;
- (int) printPictureByNumber;
- (int) uploadPictureFromFile;
- (int) clearPictures;
- (int) writeDeviceSettingRaw;
- (int) readDeviceSettingRaw;
- (int) commitSettings;
- (int) initSettings;
- (int) resetSettings;
- (int) writeDateTime;
- (int) writeLicense;
- (int) fnOperation;
- (int) fnQueryData;
- (int) fnWriteAttributes;
- (int) externalDevicePowerOn;
- (int) externalDevicePowerOff;
- (int) externalDeviceWriteData;
- (int) externalDeviceReadData;
- (int) operatorLogin;
- (int) processJson;
- (int) readDeviceSetting;
- (int) writeDeviceSetting;
- (int) beginReadRecords;
- (int) readNextRecord;
- (int) endReadRecords;
- (int) userMemoryOperation;
- (int) continuePrint;
- (int) initMgm;
- (int) utilFormTlv;
- (int) utilFormNomenclature;
- (int) utilMapping;
- (int) readModelFlags;
- (int) lineFeed;
- (int) flashFirmware;
- (int) softLockInit;
- (int) softLockQuerySessionCode;
- (int) softLockValidate;
- (int) utilCalcTax;
- (int) downloadPicture;
- (int) bluetoothRemovePairedDevices;
- (int) utilTagInfo;
- (int) utilContainerVersions;
- (int) activateLicenses;
- (int) removeLicenses;
- (int) enterKeys;
- (int) validateKeys;
- (int) enterSerialNumber;
- (int) getSerialNumberRequest;
- (int) uploadPixelBuffer;
- (int) downloadPixelBuffer;
- (int) printPixelBuffer;
- (int) utilConvertTagValue;
- (int) parseMarkingCode;
- (int) callScript;
- (int) setHeaderLines;
- (int) setFooterLines;
- (int) uploadPictureCliche;
- (int) uploadPictureMemory;
- (int) uploadPixelBufferCliche;
- (int) uploadPixelBufferMemory;
- (int) execDriverScript;
- (int) uploadDriverScript;
- (int) execDriverScriptById;
- (int) writeUniversalCountersSettings;
- (int) readUniversalCountersSettings;
- (int) queryUniversalCountersState;
- (int) resetUniversalCounters;
- (int) cacheUniversalCounters;
- (int) readUniversalCounterSum;
- (int) readUniversalCounterQuantity;
- (int) clearUniversalCountersCache;

@end
